package jesse.keeblarcraft.gui.ShopKeeperGUI;

import jesse.keeblarcraft.Keeblarcraft;
import jesse.keeblarcraft.gui.Generics.ClickableLayer;
import net.minecraft.client.gui.screen.narration.NarrationMessageBuilder;
import net.minecraft.text.Text;
import net.minecraft.util.Identifier;

// All the custom content that a store item will have. Handled by @see MerchandiseScroller.java
public class DrawableStoreItem extends ClickableLayer {
    private static final Identifier ITEM_ICON = new Identifier(Keeblarcraft.MOD_ID, "textures/gui/shopkeeper_item_slot.png");
    private Integer itemCost;
    private String itemName;
    private Integer amountSelected = 0;

    public DrawableStoreItem(String itemName, Integer itemCost) {
        this(itemName, itemCost, Text.of(""), 0, 0, 0, 0);

    }

    public DrawableStoreItem(String itemName, Integer itemCost, Text layerName, int width, int height, int startX, int startY) {
        super(ITEM_ICON, layerName, width, height, startX, startY);
        this.itemCost = itemCost;
        this.itemName = itemName;
    }

    public void Add() {
        ++this.amountSelected;
        System.out.println("Current buy amount: " + this.amountSelected);
    }

    public void Subtract() {
        --this.amountSelected;
        System.out.println("Current buy amount: " + this.amountSelected);
    }

    public Integer GetTotal() {
        return this.amountSelected * itemCost;
    }

    @Override
    public void onClick(double x, double y) {
        System.out.println("User clicked the following coordinates: [" + x + ", " + y + "]");
    }

    @Override
    protected void appendClickableNarrations(NarrationMessageBuilder builder) {}
}
